#include "common.h"
#include <sys/times.h>
#include <unistd.h>
#include <stdio.h>

clock_t start_time;
struct tms time_values;

// Tulostaa bittirivin biteittin.
void print_bit_row(BitRow row) {
	for (int i = 0; i < sizeof(BitRow) * 8; ++i)
		printf("%d", (int)((row >> (63 - i)) & 1));
	printf("\n");
}

// Nollaa sekuntikellon.
void reset_clock() {	
	times(&time_values);
	start_time = time_values.tms_utime;
}

// Palauttaa edellisest nollauksesta kuluneen ajan.
double time_elapsed() {
	times(&time_values);
	return (time_values.tms_utime - start_time) / (double)sysconf(_SC_CLK_TCK);
}

// Tulostaa merkkijonon merkit heksalukutaulukkona.
void fprint_hex_array(FILE* f, char const* str, int m) {
	fprintf(f, "{");
	fprintf(f, "0x%02X", (unsigned char)str[0]);
	for (int i = 1; i < m; ++i)
		fprintf(f, ", 0x%02X", (unsigned char)str[i]);
	fprintf(f, "}\n");
}
