#include "list.h"
#include <stdlib.h>

// Luo uuden kokonaislukulistan.
IntList* create_int_list() {
	IntList* list = (IntList*) malloc(sizeof(IntList));
	list->first = NULL;
	list->last = NULL;
	return list;
}

// Tuhoaa kokonaislukulistan.
void delete_int_list(IntList* list) {
	IntListNode* node = list->first;
	while (node) {
		IntListNode* next = node->next;
		free(node);
		node = next;
	}
	free(list);
}

// Lisää alkion listan loppuun.
void add_to_int_list(IntList* list, int num) {
	IntListNode* node = (IntListNode*) malloc(sizeof(IntListNode));
	node->num = num;
	node->next = NULL;
	if (list->first == NULL)
		list->first = node;
	else
		list->last->next = node;
	list->last = node;
}

// Suorittaa parametrina annettavan funktion kullekin listan alkiolle.
void apply_to_int_list(IntList* list, void (*func)(int)) {
	IntListNode* node = list->first;
	while (node) {
		(*func)(node->num);
		node = node->next;
	}
}

// Vertailee, ovatko listat samoja (sisältävät samat alkiot).
int equals_int_lists(const IntList* list1, const IntList* list2) {
	IntListNode* node1 = list1->first;
	IntListNode* node2 = list2->first;
	while (node1 != NULL && node2 != NULL && node1->num == node2-> num) {
		node1 = node1->next;
		node2 = node2->next;
	}
	return node1 == node2;
}
